'use strict';
angular.module('aom.directives')
  .directive('aomColourPicker', function ($ionicModal, $q, aomResourcesSrv, aomBackSrv, aomStyleSrv, aomCustomStylesSrv, aomHardwareSrv) {
    return {
      scope: {
        object: '=',
        fromJob: '='
      },
      link: function ($scope) {

        $scope.data = {
          resources: aomResourcesSrv.data.resources,
          rowClass: ''
        };
        $scope.data.rowClass = aomStyleSrv.getRowClass();

        function setupModal() {
          if ($scope.modal === undefined) {
            return $ionicModal.fromTemplateUrl('Directives/ColourPicker/colourPickerOptions.html', {
              scope: $scope,
              animation: aomHardwareSrv.isTomTom() ? 'none' : 'slideToLeft'
            }).then(function (modal) {
              $scope.modal = modal;
            });
          } else {
            return $q.when();
          }
        }

        $scope.showModal = function () {
          aomBackSrv.init($scope.hideModal, 201);
          setupModal()
            .then(function () {
              $scope.modal.show();
            });
        };

        $scope.hideModal = function () {
          aomBackSrv.exit();
          $scope.modal.hide();
        };

        $scope.colorSelected = function (colourSelected) {
          $scope.object.Data = colourSelected;
          aomCustomStylesSrv.init();
        };

      },
      templateUrl: 'App/Common/Directives/ColourPicker/colourPicker.html'
    };
  });
