'use strict';
angular.module('aom.directives')
  .directive('aomTextarea', function ($timeout, aomResourcesSrv, constants, aomComponentsSrv, aomTextScreenSrv) {
    return {
      scope: {
        selectObject: '=',
        changedMethod: '=',
        shared: '=',
        readonly: '=',
        scrollTo: '='
      },
      link: function ($scope, ele, attrs) {

        $scope.data = {
          resources: aomResourcesSrv.data.resources,
          isStandardKeyboard: $scope.selectObject.Options.KeyboardType === 0 || $scope.selectObject.Options.KeyboardType === 1,
          showInput: false
        };

        $scope.change = function () {
          if ($scope.changedMethod) {
            $scope.changedMethod($scope.selectObject.Name);
          }
        };

        $scope.typeForKeyboard = function (keyboardType) {
          return constants.keyboardTypes[keyboardType.toString()];
        };

        $scope.resetShowField = function ($event) {
          $event.stopPropagation();
          $timeout(function () {
            if ($scope.shared !== undefined) {
              $scope.shared.keyboardUp = false;
            }
            $scope.showField = false;
          }, 200);
        };

        $scope.showField = false;

        $scope.fieldFocused = function ($event) {
          if ($scope.shared !== undefined) {
            $scope.shared.keyboardUp = true;
          }
          if (!$scope.selectObject.Options.IsReadOnly && !$scope.readonly) {
            if (!$scope.data.isStandardKeyboard) {
              $scope.scrollTo(attrs.id);
              $scope.showField = true;
              $scope.data.showInput = true;
            } else {
              aomTextScreenSrv.show($scope);
            }
          }
        };
      },
      templateUrl: 'App/Common/Directives/Textarea/textarea.html'
    };
  });