'use strict';
angular.module('aom.services')
  .factory('aomLoginTaskManagerSrv', function ($q, aomCleanSrv, aomOfflineDatabasesSrv) {
    var loginTaskManagerService = {};

    loginTaskManagerService.data = {
      runTasks: false,
      remoteAttachments: []
    };

    function cleanAttachments() {
      return aomCleanSrv.cleanAttachments(loginTaskManagerService.data.remoteAttachments)
        .finally(function () {
          return $q.when();
        });
    }

    function offlineDatabases() {
      return aomOfflineDatabasesSrv.fetchOfflineDatabases()
        .then(function () {
          return aomOfflineDatabasesSrv.cleanOfflineDatabases();
        })
        .finally(function () {
          return $q.when();
        });
    }

    loginTaskManagerService.runLoginTasks = function () {
      if (loginTaskManagerService.data.runTasks) {
        loginTaskManagerService.data.runTasks = false;

        cleanAttachments()
          .then(function () {
            offlineDatabases();
          });
      }
      return $q.when();
    };

    loginTaskManagerService.setRemoteAtatchments = function (remoteAttachments) {
      if (loginTaskManagerService.data.runTasks) {
        loginTaskManagerService.data.remoteAttachments = remoteAttachments;
      }
    };

    return loginTaskManagerService;
  });