cordova.define("cordova-plugin-tomtom-bridge-navigation-launcher.bridge-navigation-launcher", function(require, exports, module) {
function TomTomBridgeNavigationLauncher() {}

TomTomBridgeNavigationLauncher.prototype.navigate = function(destination, successCallback, errorCallback) {
    if(!destination){
        var errorMsg = "TomTomBridgeNavigationLauncher: No destination";
        errorCallback(errorMsg);
        throw new Error(errorMsg);
    }
	
	destination = window.plugins.tomTomBridgeNavigationLauncher.extractCoordsFromLocationString(destination);
    var type = '';
	if(typeof(destination) == "object"){
        type = "pos";
    }else{
        type = "name";
    }

    var options = [type, destination];

    cordova.exec(successCallback, errorCallback, 'TomTomBridgeNavigationLauncher', 'navigate', options);
};

TomTomBridgeNavigationLauncher.prototype.extractCoordsFromLocationString = function(location){
	var regex = /^[-\d.]+,[\s]*[-\d.]+$/;
    if(location && typeof(location) == "string" && location.match(regex)){
        location = location.replace(/\s*/g,'');
        var parts = location.split(",");
        location = [parts[0], parts[1]];
    }
    return location;
};

// Installation constructor that binds TomTomBridgeNavigationLauncher to window
TomTomBridgeNavigationLauncher.install = function() {
  if (!window.plugins) {
    window.plugins = {};
  }
  window.plugins.tomTomBridgeNavigationLauncher = new TomTomBridgeNavigationLauncher();
  return window.plugins.tomTomBridgeNavigationLauncher;
};
cordova.addConstructor(TomTomBridgeNavigationLauncher.install);

});
